import processing.vr.*;

import android.speech.tts.TextToSpeech;
import java.util.Locale;
import java.util.Set;
import android.media.AudioManager;
import android.content.Context;

//ACHTUNG: INTERNET BEI Sketch-Permissions anhaken!!!!


//**** NEW **** NEW **** NEW **** NEW **** NEW **** NEW **** NEW **** NEW **** NEW **** NEW **** NEW **** NEW **** NEW **** NEW **** NEW **** NEW           
//OSC verwenden:
import oscP5.*;
import netP5.*;
OscP5 oscP5;
NetAddress myRemoteLocation;
String ZIEL_IP = "172.20.219.199";
int ZIEL_PORT = 12000;

//ACHTUNG:
//Android->VR anhaken

PMatrix3D eyeMat = new PMatrix3D();
TTS tts;

ArrayList<String> GEMERKTE_ZEICHEN = new ArrayList<String>();  
boolean BLICK_LINKS = false;
boolean BLICK_RECHTS = false;
float FOKUS_MINIMUM = 0.8f;

String zeichen = "ABCDEFGHIJKLMNOPQRSTUVWXZ";

int RESTZEIT = 0;
String[] AUSWAHL = {"1","2","3"};
int inx=0;

void setup() 
{    
    fullScreen(MONO);
    
    tts = new TTS();
    tts.setzeSpechgeschwindigkeit(1.0f);
    tts.setzeStimmhoehe(1.0f);
    tts.setzeLautstaerke(0.8f);
    
//**** NEW **** NEW **** NEW **** NEW **** NEW **** NEW **** NEW **** NEW **** NEW **** NEW **** NEW **** NEW **** NEW **** NEW **** NEW **** NEW           
    oscP5 = new OscP5(this,12000);
    //Zieladresse mit Port und IP
    myRemoteLocation = new NetAddress(ZIEL_IP,ZIEL_PORT);
    
}


void draw() 
{
  //Standardeinstellungen für unser Arbeiten:
  background(0);
  getEyeMatrix(eyeMat); //Kameramatrix auslesen  
  translate(eyeMat.m03, eyeMat.m13, eyeMat.m23); //Welt in Koordinatenursprung von Kamera setzen.
  lights();
  float ez_x =  eyeMat.m02;  //Einheitsvektor der aktuellen Blickrichtung
//  float ez_y =  -eyeMat.m12;
  float ez_y =  eyeMat.m12;
  float ez_z =  eyeMat.m22;  
  
  //ENDE Standardeinstellungen für unser Arbeiten:

  //PRÜFEN, OB NACH LINKS GEBLICKT WIRD:
  float[] b_links = {-1.0f,0.0f,0.0f};  //Einheitsvektor in die Blickrichtung links
  //Übereinstimmungsgrad der Blickrichtung mittels Skalarprodukt:
  float ue_links = b_links[0]*ez_x + b_links[1]*ez_y + b_links[2]*ez_z;  
  if(ue_links>FOKUS_MINIMUM)
       BLICK_LINKS = true;
  else     
       BLICK_LINKS = false;

  float[] b_rechts = {1.0f,0.0f,0.0f};  //Einheitsvektor in die Blickrichtung links
  //Übereinstimmungsgrad der Blickrichtung mittels Skalarprodukt:
  float ue_rechts = b_rechts[0]*ez_x + b_rechts[1]*ez_y + b_rechts[2]*ez_z;  
  if(ue_rechts>FOKUS_MINIMUM)
       BLICK_RECHTS = true;
  else     
       BLICK_RECHTS = false;

  if(BLICK_LINKS)
  {
      println("BLICK LINKS");
      GEMERKTE_ZEICHEN.clear();      
  }    
  if(BLICK_RECHTS)
  {
      String WORT = "";
      for(int i=0;i<GEMERKTE_ZEICHEN.size();i++)
                WORT+=GEMERKTE_ZEICHEN.get(i);
      println("BLICK RECHTS, gesprochen soll werden: "+WORT+" Wortlaenge:"+GEMERKTE_ZEICHEN.size());
      if(WORT.length()>0)
      {                
          //tts.sprich(WORT);
//**** NEW **** NEW **** NEW **** NEW **** NEW **** NEW **** NEW **** NEW **** NEW **** NEW **** NEW **** NEW **** NEW **** NEW **** NEW **** NEW           
          //NEU: das Wort soll an ein anderes Device geschickt werden und dort ausgesprochen werden!:
          OscMessage myMessage = new OscMessage("/sprich");  
          myMessage.add(WORT); /* add a string to the osc message */
          /* send the message */
          oscP5.send(myMessage, myRemoteLocation); 
          
      }    
      GEMERKTE_ZEICHEN.clear();      
  }
 
  //Buchstaben auf "Platten" zeichnen:
  textSize(64);
  for(int i=0;i<zeichen.length();i++)
  {
      pushMatrix();
      
      float z = -500.0f;
      float y = - 200 + (i/5)*100;
      float x = 100*(i%5) - 200;

      //Nähe zum Zielkreis:
      
      //1) Einheitsvektor bilden:
      float laenge = sqrt(x*x+y*y+z*z);
      float xx=x/laenge;
      float yy=y/laenge;
      float zz=z/laenge;
      
      //2) Skalarprodukt mit Blickrichtung (ez)      
      float sk = xx*ez_x + yy*ez_y + zz*ez_z;
      
      if(sk>0.99f && RESTZEIT==0)
      {
           AUSWAHL[inx]=zeichen.substring(i,i+1);
           inx++;
           inx%=AUSWAHL.length;
           
           if(AUSWAHL[0].equals(AUSWAHL[1]) && AUSWAHL[1].equals(AUSWAHL[2]))
           {
                tts.sprich(AUSWAHL[0]);
                GEMERKTE_ZEICHEN.add(AUSWAHL[0]);
                AUSWAHL[0] ="1";
                AUSWAHL[1] ="2";
                AUSWAHL[2] ="3";
           }
           
           RESTZEIT = 30;
      }
      
      translate(x,y,z); 
      noStroke();
/*      
      fill(200.0f,200.0f,200.0f);
      rect(-40, -40, 80, 80);
      translate(0,0,5); 
*/      
      fill(0,255,0);
      text(zeichen.substring(i,i+1),-20,20);
      popMatrix();
      
  }
  
  //Zielkreis zeichnen
  eye(); //Transformation realtiv zur Kamera
  translate(0, 0, 95); //Zielkreis relativ zur Kamera zeichnen
  noFill();
  stroke(255,0,0);
  ellipse(0, 0, 10, 10);
  
  if(RESTZEIT>0)
      RESTZEIT--;
}